openQA Project - action #38813

Qemu backend rewrite fallout
2018-07-25 08:47 - szarate

Status: Resolved Start date: 2018-07-25
Priority: Urgent Due date:

Assignee: rpalethorpe % Done: 0%
Category: Estimated time: 0.00 hour
Target version: Done

Difficulty:

Description

Since we have deployed the new version of the QEMU backend, we spect some fallout on tests with this backend, I'm creating this
ticket to help reviewers to tag easily (and us too)

Related issues:

Related to openQA Tests - action #38840: BIOS variable still present in test ... Resolved 2018-07-25
Related to openQA Project - action #38849: [tools] opengaworker - DIE can't... Resolved 2018-07-26
Related to openQA Tests - action #39002: test fails in bootloader Resolved 2018-08-02
Related to openQA Project - action #39035: PFLASH files handling Resolved 2018-08-01
Related to openQA Tests - action #38996: [sle][migration][sle12sp4] test fail... Resolved 2018-08-01
Related to openQA Tests - action #38963: [functional][y][fast] gemu backend r... Resolved 2018-11-09
Related to openQA Project - action #32968: [kernel][tools] Refactor QEMU back... Resolved 2018-04-24
Related to openQA Project - action #39101: Publishing of assets failed when e... Resolved 2018-08-02
Copied to openQA Project - action #38822: Qemu: Could not open backing file: ... Resolved 2018-07-25
History

#1 - 2018-07-25 08:48 - szarate

- Subject changed from gemu rewrite fallout to Qemu backend rewrite/refactor fallout

#2 - 2018-07-25 08:54 - rpalethorpe
https://openga.suse.de/tests/1857912# (ipa_ec2)

Looks like the milestone console variable is not set, possibly because the post fail hook dies.

#3 - 2018-07-25 09:06 - szarate
There's https:/openga.suse.de/tests/18579094#step/keymap_or_locale/12 that tried to load the snapshot and somehow failed afterwards:

[2018-07-25T10:28:57.0893 CEST] [debug] QEMU: gemu-system-x86_64: -blockdev driver=gcow2,node-name=hd0-overlay
1,file=hd0O-overlayl-file, cache.no-flush=on,backing=hd0: Could not open backing file: Cannot reference an exist
ing block device with additional options or a new filename

#4 - 2018-07-25 09:21 - rpalethorpe

szarate wrote:

There's https://openga. .de/tests/18579094#step/keymap_or_locale/12 that tried to load the snapshot and somehow failed afterwards:

[2018-07-25T10:28:57.0893 CEST] [debug] QEMU: gemu-system-x86_64: -blockdev driver=gcow2,node-name=hd0-ove
rlayl, file=hdO-overlayl-file, cache.no-flush=on,backing=hd0: Could not open backing file: Cannot reference
an existing block device with additional options or a new filename

This seems like the more common one so | will start working on that.
#5 - 2018-07-25 09:41 - rpalethorpe
- Copied to action #38822: Qemu: Could not open backing file: Cannot reference an existing block device with additional options or a new filename

added

#6 - 2018-07-25 11:48 - okurz

2021-12-06 1/4
Please avoid the word refactoring as it was not refactoring as in the more common meaning.

#7 - 2018-07-25 12:25 - rpalethorpe

- Subject changed from Qemu backend rewrite/refactor fallout to Qemu backend rewrite fallout

#8 - 2018-07-25 15:08 - rpalethorpe

-bios flag needs to be avoided on ARM: https://openqga.suse.de/tests/1858395/file/autoinst-log.txt

#9 - 2018-07-25 15:28 - szarate
- Related to action #38840: BIOS variable still present in test suites for aarch64 added

#10 - 2018-07-25 15:34 - szarate

Ah! | just saw that richie already noted the failure in aarch64

#11 - 2018-07-25 15:43 - rpalethorpe

| removed the BIOS var from the ARM machines.

Also hopefully fixed the issue with selecting an undefined console: https:/github.com/os-autoinst/os-autoinst/pull/996

#12 - 2018-07-25 16:29 - rpalethorpe

| think the following happens: https:/openqa.suse.de/tests/1858462+#step/force_scheduled_tasks/1 because it is trying to 'activate' the root console. It
is probably doing this because the console is reset when reverting to the snapshot. However the root console is logged in before the snapshot is
taken.

The problem here is that we are confusing resetting/activating consoles in the backend with logging them in on the SUT (the two can be different
because of snapshots). Possibly the distribution code could be changed to handle the situation where a console is already logged in during activation.

#13 - 2018-07-26 07:36 - rpalethorpe

| don't think my changes introduced the problem with reactivating the console as the code to reset them has always been there. However only
consoles activated since the last snapshot should be reset, but it seems the root console, which was active before the snapshot, is also being reset.

This is a tricky bit of code though so my confidence is low.

#14 - 2018-07-26 07:40 - rpalethorpe

We should probably add some "self tests" within the suse test suite for testing reverting to snapshots under a number of circumstances.

#15 - 2018-07-26 11:29 - rpalethorpe

Boot failure on USBInstall is possibly caused by changes to how the USB storage device is handled.
https://openga.suse.de/tests/1859849#

#16 - 2018-07-26 12:38 - rpalethorpe

The USB storage device appears in different positions in the boot order depending on the exact command line options used. It is not clear if this is
deterministic or not. However the bootindex device parameter can hopefully be used to solve this, so we don't even need to go into the boot menu:
https://github.com/os-autoinst/os-autoinst/pull/997

#17 - 2018-07-26 14:54 - rpalethorpe

The version of QEMU on at least some PowerPC workers is much too old (2.6.2).

#18 - 2018-07-26 15:29 - szarate
So PPC64 snapshots are disabled for now, https:/gitlab.suse.de/openga/salt-pillars-openga/commit/cf7b91c1a3e810f9a75d3b9213c3ac0945cch456

#19 - 2018-07-26 19:55 - rpalethorpe

FFS, OpenQA has two different functions which decide if a setting is an asset. One here which | updated and one here which I did not update.

The pflash assets are being stored in the correct place because of the first, but the variable is not being substituted with the absolute path due to the
second.

#20 - 2018-07-27 08:03 - szarate
- Related to action #38849: [tools] openqaworker - DIE can't open gmp added

#21 - 2018-07-27 08:36 - coolo
That obviously did not help, so revert that again

Update the machines to SP3 - powergaworker-qgam-1 runs on SP3 without major problems:
https://openga.suse.de/admin/workers/1049

#22 - 2018-07-27 08:41 - szarate

coolo ok, upgrading the workers then

#23 - 2018-07-27 11:34 - szarate

All power workers have been upgraded, need only to test malbec. Will probably use the chance to reduce the number of workers there to 3. Since
there have been reports that it's causing some trouble

#24 - 2018-07-30 07:05 - rpalethorpe

This test is dieing because it is trying to download the pflash drive which doesn't exist for none UEFI tests: https://openga.opensuse.org/tests/715933.

The variable needs to be ignored when UEFI is not set or we somehow need to add the variable when UEFI is set.

#25 - 2018-07-30 07:56 - rpalethorpe

From the discussion on IRC: We could add a code hook before isotovideo is run which allows assets to be cached/downloaded by the test suite
and/or backend.

So we could revert the changes which detect pflash vars as a hdd asset and add a code hook to the backend instead which downloads the asset and
changes the variable to include its full path.

#26 - 2018-07-30 08:09 - rpalethorpe
As a temporary workaround the backend could publish an empty vars file if PUBLISH_PFLASH_VARS is present, but UEFI is not set.

#27 - 2018-07-30 09:11 - rpalethorpe

https://github.com/os-autoinst/os-autoinst/pull/999/files

#28 - 2018-07-30 10:59 - okurz

Pretty sure that https://openga.suse.de/tests/18731944#step/yast?2_bootloader/6 is related as well. The disk used for installing the bootloader changed.
Please make sure to address this as well. If you think it's acceptable as is then just create a new corresponding needle to cover this.

#29 - 2018-07-30 11:23 - okurz
https://openga.suse.de/tests/18743104#step/grub_test/4 in the USBinstall test suite also seems to be related.

#30 - 2018-07-30 14:54 - rpalethorpe
- Status changed from New to In Progress

- Assignee set to rpalethorpe

Another potential problem is that | am using '-boot order=' and bootindex at the same time. However | have not seen any problems yet. IIRC it
depends on the VM's bios firmware if it explodes or not.

#31 - 2018-07-31 04:03 - szarate

| have applied the following patch: https:/github.com/os-autoinst/openQA/pull/1732 which seems to work, and should allow us to carry on testing
while an appropriate solution is found.

#32 - 2018-07-31 08:39 - rpalethorpe

Doh. The serial file is probably being truncated on reverting to a snapshot. Need to change the serial log to append.

#33 - 2018-07-31 13:05 - szarate

Looks like for some tests, the worker is not even downloading the pflash https:/openqga.suse.de/tests/1876680

#34 - 2018-07-31 13:32 - szarate

Looks like some jobs https:/openga.suse.de/tests/1876867#step/online_migration_setup/6
https://openga.suse.de/tests/1876803#step/online_migration_setup/2 are failing (perhaps the devices are just wrong?)

#35 - 2018-08-01 09:54 - szarate
- Related to action #39002: test fails in bootloader added
#36 - 2018-08-01 11:52 - szarate

| have failed to track this one: https://openga.opensuse.org/tests/717043#step/yast2_nfs_client/18

#37 - 2018-08-01 11:57 - szarate
- Related to action #39035: PFLASH files handling added

#38 - 2018-08-01 12:03 - szarate
- Related to action #38996: [sle][migration][sle12sp4] test fails in boot_to_desktop -- need wait to assert needle inst-slof added

#39 - 2018-08-01 12:43 - rpalethorpe

- Related to action #38963: [functional][y][fast] gemu backend rewrite: upgrade not possible anymore in many scenarios added

#40 - 2018-08-01 14:29 - rpalethorpe
- Related to action #32968: [kernel][tools] Refactor QEMU backend - Create QEMU process manager and save configuration state added

#41 - 2018-08-01 15:30 - szarate
looks like another one more in the saga: https:/openga.suse.de/tests/1882747

#42 - 2018-08-02 07:36 - rpalethorpe

szarate wrote:

looks like another one more in the saga: https://openga.suse.de/tests/1882747

https://github.com/os-autoinst/os-autoinst/pull/1005

Also ARM snapshots are timing out on opensuse. The aarch64 machines have been given 4GB of RAM which on ARM takes slightly more than 4
minutes to compress and save to disk. If the RAM size needs to be this large then snapshots probably need to be disabled again. However we really
want snapshots enabled on SLE, but | think the RAM size is less than 2GB there which should be OK.

Ideally we want snapshots enabled everywhere, but | will follow that up in the main ticket.

#43 - 2018-08-02 13:37 - szarate

- Related to action #39101: Publishing of assets failed when extracting pflash-vars qcow image. added

#44 - 2018-08-22 06:41 - rpalethorpe

- Status changed from In Progress to Resolved

This still takes up some time, but the vast majority of it is over.

#46 - 2018-09-14 12:17 - coolo

- Target version changed from Current Sprint to Done

#47 - 2018-09-24 13:37 - zluo

sorry, wrong entry here, pls ignore...
